<template>
<div v-if="profileTeam && profileTeam.length && initData && initData.length">
    <el-collapse v-model="opened" @change="handleChange">
        <team-member v-for="(member, index) in profileTeam" :key="index" :member-id="index" :ref="`member${index}`"
            :init-data="initData[index]" @deleted="handleChange(null)"/>
    </el-collapse>
</div>
<div v-else class="no_data">No team data</div>
</template>

<script>
import { mapState } from 'vuex';
import TeamMember from './TeamMember';

export default {
    components: {
        TeamMember,
    },
    props: {
        /** team details from server */
        initData: {
            type: Array,
            required: false,
        },
    },
    watch: {
        invalidIdToScroll(newVal) {
            if (newVal && newVal.includes('.team.')) {
                this.openInvalidSection(newVal);
            }
        },
    },
    data() {
        return {
            opened: [],
        };
    },
    computed: {
        ...mapState({
            profileTeam: state => state.editUser.profileTeam,
            deletedMembers: state => state.editUser.deleted_team_members,
            invalidIdToScroll: state => state.validation.invalidIdToScroll,
        }),
    },
    methods: {
        /**
         * Handler for changing open status of collapse section
         * @param {Array} val - current opened sections
         */
        handleChange(val = null) {
            const currentOpened = !val ? this.opened : val;
            // don't open sections of deleted teammates
            this.opened = currentOpened.filter(id => this.deletedMembers.indexOf(id) === -1);
        },
        /**
         * Discard changes for all Team Member components
         */
        discardChanges() {
            Object.values(this.$refs).forEach(([ref]) => {
                ref.discardChanges();
            });
        },
        /**
         * Handler for opening collapse section that have invalid parameters
         * @param {String} uid - ID of invalid parameter
         */
        openInvalidSection(uid) {
            const collapseId = Object.keys(this.profileTeam).reduce((acc, memberIndex) => {
                const collapseItemName = `team.${memberIndex}.`;
                if (uid.includes(collapseItemName)) {
                    return collapseItemName;
                }
                return acc;
            }, null);
            if (collapseId && !this.opened.includes(collapseId)) {
                this.opened.push(collapseId);
            }
        },
    },
};
</script>
